<template>
  <div class="vlue-mobile-menu-container hide-on-desktop"
    v-if="websiteGeneration || portraitNotLandscape"
    :class="{ expanded }"
    :style="{ width : viewportWidth }">
    <div class="vlue-mobile-menu"
      :style="cssVars"
      :class="[
        { 'expand'         : website.mobileMenu.type                == 'expand' },
        { 'slide'          : website.mobileMenu.type                == 'slide'  },
        { 'aligned-left'   : website.mobileMenu.align.split('-')[1] == 'left'   },
        { 'aligned-right'  : website.mobileMenu.align.split('-')[1] == 'right'  },
        { 'aligned-top'    : website.mobileMenu.align.split('-')[0] == 'top'    },
        { 'aligned-bottom' : website.mobileMenu.align.split('-')[0] == 'bottom' },
      ]">
      <mobile-menu-nav
        v-if="website.mobileMenu.type == 'expand'"
        v-on:itemClicked="menuButtonClicked()">
      </mobile-menu-nav>
      <button class="vlue-mobile-menu-button"
        :class="[
          { 'aligned-left'   : website.mobileMenu.align.split('-')[1] == 'left'   },
          { 'aligned-right'  : website.mobileMenu.align.split('-')[1] == 'right'  },
          { 'aligned-top'    : website.mobileMenu.align.split('-')[0] == 'top'    },
          { 'aligned-bottom' : website.mobileMenu.align.split('-')[0] == 'bottom' },
        ]"
        type="button"
        v-on:click="menuButtonClicked()">
        <div class="vlue-mobile-menu-button-line"
          :style="cssVars"
          v-for="element in [1,2,3]">
        </div>
      </button>
    </div>
    <mobile-menu-nav
      v-if="website.mobileMenu.type == 'slide'"
      v-on:itemClicked="menuButtonClicked()">
    </mobile-menu-nav>
  </div>
</template>

<script lang="ts">
import Vue from 'vue'
import mobileMenuNav from './MobileMenuNav.vue'
import { mapState } from 'vuex'

export default Vue.extend({
  computed: {
    ...mapState([
      'viewportWidth',
      'portraitNotLandscape',
      'websiteGeneration',
      'website',
    ]),
    cssVars(): any {
      return {
        '--mobile-menu-color-a': this.website.mobileMenu.colorA || 'black',
        '--mobile-menu-color-b': this.website.mobileMenu.colorB || 'white',
      }
    },
  },
  components: {
    mobileMenuNav,
  },
  data() {
    return {
      expanded: false,
    }
  },
  methods: {
    menuButtonClicked() {
      this.expanded = !this.expanded;
    },
  },
})
</script>

<style lang="scss">
@import "../../style/vars.scss";

.vlue-mobile-menu-container {
  position: sticky;
  bottom: 0;
  height: 100vh;
  margin-top: -100vh;
  pointer-events: none;
  overflow: hidden;
  z-index: 10;
  transition: $vlue-transition-duration-long;
  &.expanded {
    background: #0005;
    .vlue-mobile-menu {
      &.expand {
        width: calc(100% - 40px);
        height: calc(100% - 40px);
        border-radius: 10px;
      }
      &.slide.aligned-left {
        left: calc(100% - 140px);
      }
      &.slide.aligned-right {
        right: calc(100% - 140px);
      }
      .vlue-mobile-menu-button {
        transform: rotate(-90deg);
        .vlue-mobile-menu-button-line {
          box-shadow: 0 -5px 5px #0005;
          &:nth-child(1) {
            top: 50%;
            transform: translate(-50%,-50%) rotate(315deg);
          }
          &:nth-child(2) {
            top: 50%;
            width: 0;
            transform: translate(-50%,-50%) rotate(270deg);
          }
          &:nth-child(3) {
            top: 50%;
            transform: translate(-50%,-50%) rotate(-135deg);
          }
        }
      }
    }
  }
  .vlue-mobile-menu,
  .vlue-mobile-menu-button {
    &.aligned-left {
      left: 0;
    }
    &.aligned-right {
      right: 0;
    }
    &.aligned-top {
      top: 0;
    }
    &.aligned-bottom {
      bottom: 0;
    }
  }
  .vlue-mobile-menu {
    position: absolute;
    margin: 20px;
    width: 100px;
    height: 100px;
    border-radius: 50px;
    pointer-events: all;
    transition: $vlue-transition-duration-long;
    box-shadow: 0 5px 5px #0005;
    overflow: hidden;
    background: var(--mobile-menu-color-b);
    .vlue-mobile-menu-button {
      width: 100px;
      height: 100px;
      transition: $vlue-transition-duration-long;
      background: transparent;
      border: none;
      position: absolute;
      .vlue-mobile-menu-button-line {
        position: absolute;
        width: 48px;
        height: 6px;
        border-radius: 10px;
        left: 50%;
        transform: translate(-50%, -50%);
        transition: $vlue-transition-duration-long;
        box-shadow: 0 5px 5px #0005;
        background: var(--mobile-menu-color-a);
        &:nth-child(1) {
          top: 38%;
        }
        &:nth-child(2) {
          top: 50%;
        }
        &:nth-child(3) {
          top: 62%;
        }
      }
    }
  }
}
</style>
